#!/bin/sh
cmnd=/usr/local/bin/ppf

#OUTPUT=/dev/null
OUTPUT=/dev/tty

clearval=0
goreg=20

wrcmnd=0x10
rdcmnd=0x20
fbcmnd=0x30

cmndreg=10
rtnreg=30

ICVO=02000200
ICVI=02000200
IFB=02000100


fixarglen()
{
  argfixlen=7
  argin="0000000$1"
  arglen=`expr length "$argin"`
 ##  echo "arglen: $arglen"
  argcut=$(($arglen-$argfixlen))
 ##  echo "argcut $argcut"
  fixargout=`echo -n "$argin" | cut -b $argcut-`
 ##  echo $fixargout  
}


## Call this with a hex reg address  and it reads and returns
## a hex value in 0xX format.
rfpgareg() 
{ 
 for i in `/usr/local/bin/ppf r $1 2 | tr '.' '\n'` ; do
   str=${str},${i}
   let n=$n+1
##  var=`echo "var${n}"`
##  echo $var is ... ${i}

   
   if [ $n -eq 7 ]; then
        regdat=`echo -n "${i}" | sed 's/\(.*\)./\1/'`
 ##     echo "RegVal $regdat"
        regdat=`echo -n "$regdat" | cut -b 3-`
 ##     echo "RegVal $regdat ClearVal $clearval"
  
   elif [ $n -eq 9 ]; then
        highregdat=`echo -n "${i}" | sed 's/\(.*\)./\1/'`
        highregdat=`echo -n "$highregdat" | cut -b 3-`
   fi 
   done
}

sendfbcmnd()
{
  fixarglen $1
  foff=$fixargout
  fixarglen $2
  freg=$fixargout
  fixarglen $3
  fdata=$fixargout

  fofflow=`echo -n $foff | cut -b 5-`
  foffhigh=`echo -n $foff | cut -b -4`

  freglow=`echo -n $freg | cut -b 5-`
  freghigh=`echo -n $freg | cut -b -4`

  fdatalow=`echo -n $fdata | cut -b 5-`
  fdatahigh=`echo -n $fdata | cut -b -4`

  ##echo "reg low $fpgareglow"
  ##echo "reg high $fpgareghigh"
  $cmnd w $cmndreg $fbcmnd $fofflow $foffhigh > $OUTPUT
  $cmnd w 20 1 > $OUTPUT
  
  rfpgareg $goreg
  ##echo "readval $regdat clearval $clearval"

  while [ $regdat -ne 0 ]
  do
   echo "while readval $regdat"
   rfpgareg $goreg
  done
  rfpgareg $rtnreg

}

date
sendfbcmnd 0  
sendfbcmnd 1
date


