#!/bin/sh

DEV=$1
DEVFILE=/dev/${DEV}
GNAME=`echo $1 | sed 's/[0-9]//g'`
DPATH=`ls -l /sys/block/$GNAME/device`
USBNBR=`echo $DPATH | awk -F/ '{print $11}' | awk -F. '{print $2}'`

BOXNBR=$USBNBR
if [ 1 -eq $USBNBR ]; then
        BOXNBR=3;
fi 
if [ 3 -eq $USBNBR ]; then
        BOXNBR=1;
fi 

if [ ! -e /media/USB${BOXNBR} ]; then               
	echo "Device is ${DEVFILE} on USB port# ${USBNBR} box# ${BOXNBR} " > /dev/console
	cd /media; ln -s ${DEV} USB${BOXNBR} ;
fi                
                
