-- This configuration has 2 video inputs each of which is encoded -- at IBBRBP AVC (high quality), IP (low quality), and MJPEG.
FORMAT	= "480i";
VOUT	= "svideo";

PREVIEW = 2;

if(PREVIEW == 1) then 
		LVPP_LIVE_PREVIEW_TIME_DELAY = -3003;
		BURNIN_TIMECODE = 0;
end

-- streaming
HOST = HOST or "192.168.40.102";
SERVER = "NULL";

-- Streaming protocol 0 for nothing, 1 for UDP, 2 for RTP
STREAMING_ENCCH     = STREAMING_ENCCH or 2;
STREAMING_ENCCH_2   = STREAMING_ENCCH_2 or 2;
STREAMING_MJPEGCH  = STREAMING_MJPEGCH or 1;

ENCCH_TO_STREAM = 2;
ENCCH_2_TO_STREAM = 2;
MJPEGCH_TO_STREAM = 2;

ENCCH_TO_STORE = 0;
ENCCH_2_TO_STORE = 0;
MJPEGCH_TO_STORE = 0;

--[[
-- single cloned input settings
--VIN = "svideo";
--INPUTFORMAT = "480i";
--MAIN_CAPTURE_FRAMES = 10;
--RENDER_BFF = 1;
--]]


MAIN_CAPTURE_FRAMES = 7;

-- set to use 8 references and a reasonable avsn skew
NUM_AVC_REFERENCES = 8;
AVC_RECON_PREVIEW_TIME_DELAY = -12012;

ENCCH = 2;
MAX_LVPP_USED = 2;
DECCH = 2;
ENCCH_2 = 2;
MJPEGCH = 2;

AUDIO_CODEC = "g711";
AUDIO_SAMPLE_RATE = 8000;
AUDIO_BIT_RATE = 16000;

ENCW_2 = 352;
ENCH_2 = 240;

SECONDARY_STC_PER_FRAME = 3003;
SECONDARY_STC_PER_OUTPUT_FRAME = 6006;

AVCDEC_REFERENCE_FRAMES = 7;

--MAIN_GOP_STRUCTURE = "IBBRBP";
MAIN_GOP_STRUCTURE = "IBBRBP";
MAIN_FRAME_STRUCTURE = "mbaff";
MAIN_CLOSED_GOP = 1;

SECONDARY_GOP_STRUCTURE = "IP";
SECONDARY_FRAME_STRUCTURE = "frame";
SECONDARY_CLOSED_GOP = 1;

BITRATE = {};
BITRATE[1] = 3000000;
BITRATE[2] = 3000000;
BITRATE[3] = 3000000;
BITRATE[4] = 3000000;

BITRATE_2 = {};
BITRATE_2[1] = 500000;
BITRATE_2[2] = 500000;
BITRATE_2[3] = 500000;
BITRATE_2[4] = 500000;

BITRATE_MJPEG = {};
BITRATE_MJPEG[1] = 500000;
BITRATE_MJPEG[2] = 500000;
BITRATE_MJPEG[3] = 500000;
BITRATE_MJPEG[4] = 500000;

JPEG_CAPTURE_INTERVAL = 45000;
JPEG_FPS = 2;

MAIN_ENC_BUFFER_SIZE = 1500000;
SECONDARY_ENC_BUFFER_SIZE = 750000;

MAIN_ENC_GUARD_BAND = 200;
SECONDARY_ENC_GUARD_BAND = 200;
JPEG_ENC_GUARD_BAND = 300;

-- We need to set these to 0 for VLC 0.8.6h compatibility
MAIN_IP_FIELD_CODING = 0;
SECONDARY_IP_FIELD_CODING = 0;

SECONDARY_TF_Y_BYPASS = 0;


function play(i)
    if (PREVIEW == 2) then
      hiderecon(i);
    end
    hidelive(i);
    showplayback(i);
    if (DECCH == 1) then
        startplayback(i,1);
    elseif (DECCH > 1) then
    	startplayback(i,i);
    end
end


